#!/bin/sh
#
# Start the network....
#
#
# $1 : Modus operandi {start|stop|reload|restart}
# ret: {0:process all ok | 1:part of/whole process failed}
#
# $2 : Manual operation. Interface to operate with.
#
# $ jeudi 11/24/05 08:56:21 md(root) mathieu.deschamps@com2gether.net$
#
##
INTFILE=/etc/network/interfaces
NETSERV=/etc/network/interfaces.service
RECEPTACLE=
##
#
MODUS=$1
# Maybe its run as a non rcS-launcher call (ie manual call)
[ "x$VERBOSE" = "x" ] && VERBOSE=no
[ "x$2" != "x" ] && INTERFACE="$2"
# Source common functions
. /etc/init.d/rc.common


start() {
 		echo -n "Starting network..."; RET=0
	if [ ! -r "$NETSERV" ]; then echo "Net Service file $NETSERV inexistant or unreadable";return 1;fi		
	
	# Starts everything in $NETENV interface service file
	for eth in `egrep -v "^#" $NETSERV | cut -f1` 
	do
	 	## Check if no ~ (tilde) is prefixed to interface. If false, this means set_inter on it but don't ifupdown up it.
		start=yes
		eth2=`echo ${eth} | egrep -e "^~" | tr -d "~"`
		if [ ! -z $eth2 ]; then eth="$eth2"; start=no;fi
		## On manual call escape $eth that isn't $INTERFACE given parameter : go to next one 	
		if [ "x$INTERFACE" != "x" ] && [ "$eth" != "$INTERFACE" ]; then continue;fi
		##
		type=`egrep -v "^#" $NETSERV | grep -ie "$eth" | cut -f2`
		## Evades startup of ppp interface type : that's a S??ppp.sh script matter
                if [ $type != "ppp" ]; then
			echo -n "${eth}(${type}):"
			check_inter $eth "$INTFILE"
			if [ "$?" -ne 0 ];then
				echo  "No $eth interface in $INTFILE" ; RET=0 
			fi
			##
			set_inter $eth $type "$INTFILE"
			case $? in
				70) RET="$?";echo "error on insmoding modules"			;break	;;
				90) RET="$?";echo "error on finding correct ip for ADDRESS"	;break  ;;
				91) RET="$?";echo "error on finding correct ip for NETMASK"	;break  ;;
				92) RET="$?";echo "error on finding correct ip for BROADCAST"	;break  ;;
				93) RET="$?";echo "error on finding correct ip for NETWORK"	;break  ;;
				94) RET="$?";echo "error on finding correct ip for GATEWAY"	;break  ;;
				99) RET="$?";echo "set_interface : incorrect call context"	;break  ;;
				0)  	RET="$?";[ $VERBOSE = yes ] && echo -en "$eth is configured\t"
					##Maximun connectivity : try to activate every link if not tilded in NETSERV
					if [ "$start" = yes ]; then
						ifupdown $eth up
						if [ "$?" -ne 0 ]; then
							[ $VERBOSE = yes ] && echo  "error in putting up $eth." ;
						else
							[ $VERBOSE = yes ] && echo -en "$eth is up and running\t"
						fi
					else
						ifupdown $eth down
						[ $VERBOSE = yes ] && echo -en "$eth is ready\t"
					fi
												        ;;
				*)  RET="$?";echo "error in ifconfig's setting up $eth."		;;
			esac		
			
		echo -n "done."
		fi
	done
	echo -e "\t"
	/usr/sbin/ethmngt s
return $RET
}	

stop() {
		echo -n "Stopping network..."; RET=0
	 if [ ! -r "$NETSERV" ]; then echo "Net Service file $NETSERV inexistant or unreadable";return 1;fi

	# Stops everything static in $NETENV interface service file
        for eth in `egrep -v "^#" $NETSERV | cut -f1`
	do
                # Check if no ~ (tilde) is prefixed to interface. Anyway it'll stop every interface still it need
		# a correct non tilded name.
                eth2=`echo ${eth} | egrep -e "^~" | tr -d "~"`
                if [ ! -z $eth2 ]; then eth="$eth2";fi
                ## On manual call escape $eth that isn't $INTERFACE given parameter : go to next one
                if [ "x$INTERFACE" != "x" ] && [ "$eth" != "$INTERFACE" ]; then continue;fi
		##
                type=`egrep -v "^#" $NETSERV | grep -ie "$eth" | cut -f2`
	        ## Evades stopping ppp interface type : that's a S??ppp.sh script matter
                if [ $type != "ppp" ]; then
			check_inter $eth "$INTFILE"
			if [ "$?" -ne 0 ];then
				echo "No $eth interface in $INTFILE" ; RET=0
			fi

			ifupdown $eth down
			if [ "$?" -ne 0 ]; then
				echo "error in putting down $eth." ; RET=1
			else
				[ $VERBOSE = yes ] && echo -en "$eth is down and stopped\t"
			fi
		echo -n "$eth:done."
		fi
	done
	echo -e "\t"
	/usr/sbin/ethmngt e
return $RET
}


restart() {
	stop
	/bin/usleep 5
	start
}	


status() {
	if [ ! -r "$NETSERV" ]; then echo "Net Service file $NETSERV inexistant or unreadable"
	 	ifconfig -a
	else
		# Stats everything in $NETENV interface service file
	        for eth in `egrep -v "^#" $NETSERV | cut -f1`
        	do	
			# Check if no ~ (tilde) is prefixed to interface.It need
			# a correct non tilded name to status a existing interface.
			eth2=`echo ${eth} | egrep -e "^~" | tr -d "~"`
			if [ ! -z $eth2 ]; then eth="$eth2";fi
			## On manual call escape $eth that isn't $INTERFACE given parameter : go to next one
			if [ "x$INTERFACE" != "x" ] && [ "$eth" != "$INTERFACE" ]; then continue;fi
			##
			type=`egrep -v "^#" $NETSERV | grep -ie "$eth" | cut -f2`
			## Evades stopping ppp interface type : that's a S??ppp.sh script matter
			if [ $type != "ppp" ]; then
				check_inter $eth "$INTFILE"
				if [ "$?" -ne 0 ];then
					echo "No $eth interface" ; RET=0
				fi			
				ifupdown $eth
				# keep the highest condition in the return state
				[ "$?" -gt "$RET" ] && RET="$?"
			fi
		done
	fi
	return $RET
}

case $MODUS in
  start)
  	start
	;;
  stop)
  	stop
	;;
  restart|reload)
  	restart
	;;
  status)
	status
	;;
  *)
	echo "Usage: S40network.sh {start|stop|status|restart}"
	return 1
	;;
esac

RET=$?
unset ADR NETM NETW BROAD GATE REM SERVICE
exit $RET
 
