#! /bin/sh
#
# Start the Trivial Transfer protocol facility...
#
#
# $1 : Modus operandi {start|stop|reload|restart}
# ret: {0:process all ok | 1:part/whole process failed}
#
##
INTFILE=/etc/services
##
#
MODUS=$1
#
# Options : 
# 	-l : run standalone (not from xinetd)
#	-U : umask 	(default : 600)
#	-t : timeout 	(default : 900s)
#	-v : icrease verbosity (can be specified several times)
#	-c : allow new file creation
#
ARGU="-v -l -c "
#
NAME=in.tftpd
DAEMON=/usr/sbin/$NAME
#
#

#
# Start
#
# ret: {0: started | 1: not started}
#
start () {
	 echo -n "Starting Tftp service..."
	 [ ! -r $INTFILE ] &&  echo "error in reading $INTFILE." && return 1 
	
	 $DAEMON $ARGU

  	 [ $? -eq 0 ] &&  echo "done." || echo " error in starting $NAME" 
	return $ret

}


#
# Stop
#
#
stop () {
	echo -n "Stopping Tftp service..."
	/usr/bin/killall $NAME 

	[ $? -eq 0 ] && echo "done." || echo "error in stopping $NAME."  
	return $ret
}



restart() {
        stop
        start
}

case "$MODUS" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  restart|reload)
        restart
        ;;
  *)
        echo $"Usage: $0 {start|stop|restart}"
        exit 1
esac

unset DEAMON ARGU NAME INTFILE 
exit $?

