#! /bin/sh
#
# Starts a PPP connection...
##
# Limitations   : Conceived for a single ppp entry, a modem ppp connection
#
# The ppp entry ...
# Principle1: If it is in NETSERV, Elite is set to hangup on call-out (a remote dial to be exact)
# Principle2: If it is in INTFILE but not in NETSERV, it means scripts are just prepared
# Principle3: If it is niether on both, how do you want it to work ? If you don't want it put it in rc.service file
# Principle : *Normally*  it got to be coherent in both. Non existance in INTFILE is *fatal*.
##
#
# $1 : Modus operandi {start|stop|restart|channel}
# $2 : Tty Channel filename (for channel only)
# ret: {0:process all ok | 1:part/whole process failed}
#
# $ jeudi 11/24/05 08:56:21 md(root) mathieu.deschamps@com2gether.net$
#
##
PPPOPTIONFILE=/etc/network/ppp
INTFILE=/etc/network/interfaces
NETSERV=/etc/network/interfaces.service
DEFAULT_PPP_OPTIONS="lock modem /dev/modem 19200 "
CHANNEL="/dev/ttyS5 /dev/ttyS6"
CHAN=`echo $CHANNEL | cut -f1 -d" "` 
#
# AT dial scripts (input)
#
ATDIALIN=/etc/pppdial
ATDIALOUT=/etc/pppring
##
## Generated connection scripts (output)
## # Remember you pententialy can only write on tmpfs (/tmp)
##
SCRIPTIN=/tmp/ppp-din
SCRIPTOUT=/tmp/ppp-dout
##
#
MODUS=$1
# Maybe its run as a non rcS-launcher call (ie manual call)
# check it out with rcS exported variable VERBOSE
if [ "x$VERBOSE" = "x" ]; then 
	VERBOSE=no
fi
# Source common functions
. /etc/init.d/rc.common



# Set ethernet interface with given parameters
#
#
# set_pppinter $1 with $3 interface file.
# $1 : interface name
# $2 : Do ifconfig/routing commands now {1: now | 0: later}
# $3 : Interface file
#
# find_ip returns  :
#       {90: error on finding correct ip for $ADR
#        91: error on finding correct ip for $NETM
#        92: error on finding correct ip for $BROAD
#        93: error on finding correct ip for $NETW
#        94: error on finding correct ip for $GATE
#        95: error on finding correct ip for $REM}
# insert_module returns :
#       {70: error insmoding}
# returns more likely : {99: incorrect call context | 0:ok | 1 and greater : ifconfig & route err}
#
set_pppinter () {


	if [ -z "x$2" ] || [ "$2" != "now" -a  "$2" != "later" ]; then
		echo -en "Ifconfiguring ppp interface now or later ?\t"
		return 99 
	else
		IFCFG=$2
	fi  

	
        ETHTYPE=ppp

        if [ -r "$3" ]; then
                FILE="$3"
        else
                echo -en "$FILE inexistant or unreadable\t"
                return 99
        fi

        if [ "x$1" != "x" ]; then
                ETH="$1"
        else
                echo " ERROR : interface to set up not given !"
                return 99
        fi

        # Call the parser, in the end is expected to be set ADR,NETM,BROAD,NETW,GATE,REM and CURINTLINE,NEXINTLINE
        parse_inter $ETH $FILE

	find_ip $ADR $CURINTLINE $NEXINTLINE
	 if [ "$?" -eq 0 ]; then ADR=$RECEPTACLE;  else return  90;fi
	find_ip $NETM $CURINTLINE $NEXINTLINE
	 if [ "$?" -eq 0 ]; then NETM=$RECEPTACLE; else return  91;fi
	find_ip $BROAD $CURINTLINE $NEXINTLINE
	 if [ "$?" -eq 0 ]; then BROAD=$RECEPTACLE;else return  92;fi
	find_ip $NETW $CURINTLINE $NEXINTLINE
	 if [ "$?" -eq 0 ]; then NETW=$RECEPTACLE; else return  93;fi
	find_ip $GATE $CURINTLINE $NEXINTLINE
	 if [ "$?" -eq 0 ]; then GATE=$RECEPTACLE; else return  94;fi
	find_ip $REM $CURINTLINE $NEXINTLINE
	 if [ "$?" -eq 0 ]; then REM=$RECEPTACLE;  else return  95;fi
	insert_module $ETHTYPE

	unset RECEPTACLE
	# if PPP has a demand option then we can ifconfig now without waiting
	# for host to be contacted. Otherwise, we have to evade because 
	# ifconfiging comes after, at script lauching time when remote host has been contacted.
	if [ $IFCFG = "now" ]; then
		[ $VERBOSE = yes ] && echo -e "ifconfig $ETH $ADR netmask $NETM broadcast $BROAD\t"
		ifconfig $ETH $ADR netmask $NETM broadcast $BROAD >/dev/null 2>&1

		# BTW add a route to our network (typo: route add 192.168.0.0 eth0)
		if [  "x$NETW" != "x" ]; then
				[ $VERBOSE = yes ] && echo -e "route add $NETW $ETH\t"
			route add -net $NETW netmask $NETM $ETH                         2>/dev/null
				[ $VERBOSE = yes ] && [ $? -ne 0 ] && echo -en "Unable to add network route for $ETH\t"
		else
			[ $VERBOSE = yes ] && echo -en "No network definition to add a network route for $ETH\t"
		fi
	fi

return 0
}	



#
# Set the dialing scripts with PPPOPTION file
#
# $1 : modem dial origin {in | out}.
#	In : machine dials a number and gets connected
#	Out: machine awaits a ring and makes connection
# $2 : this local machine IP address
# $3 : remote machine IP address
# $4 : PPP option file
#
# ret : {0:ok | 1 : parameter inconsistency  | 2 : PPP Options err }
#
config_dial() {

	case "$1" in
		in|out)							SENS=$1;;
		*) echo " ERROR : config dial is either in or out !";return 1 ;;
	esac

	if [ ! -z "$2" ]; then ADR=$2;else return 1 ;fi
	if [ ! -z "$3" ]; then REM=$3;else return 1 ;fi
	
	if [ ! -r "$4" ]; then
	  echo "PPP config. file $4  inexistant or unreadable"; return 1
	else
		PPPOPTIONFILE="$4"
	fi

	if [ $VERBOSE = yes ];then
	        if [ $SENS = in ]; then 
			echo -en "\nConfiguring a dialing script ${SCRIPTIN}..."
		else
			#SENS is out
			echo -en "\nConfiguring a callout script ${SCRIPTOUT}..."
		fi
	fi
        # Set variables to set others in PPPOTIONS file
        if [ $SENS = in ]; then DIALER_SCRIPT=${ATDIALIN};else DIALER_SCRIPT=${ATDIALOUT};fi
        LOCAL_IP=$ADR;REMOTE_IP=$REM

	# source PPPOPTION to dial
        . $PPPOPTIONFILE
	# This is useless now
	unset DIALER_SCRIPT LOCAL_IP REMOTE_IP
	
	# If no PPP Options are set in PPPOPTIONFILE (consider having a rest meanwhile)
	# use default
	if [ -z "$PPPOPTIONSOUT" ] || [ -z "$PPPOPTIONSIN" ]; then
		[ $VERBOSE = yes ] && echo -en "Using default PPP connection options\t"
		PPPOPTIONSOUT=$DEFAULT_PPP_OPTIONS
		PPPOPTIONSIN=$PPPOPTIONSOUT
	fi
	
	# some sanity checks on PPPOPTION file value
        if [ "x$MODEM"          = "x" ]; then  echo "No ppp device type specified !";return 2;fi
        if [ "x$CONNECT"  	= "x" ]; then  echo "No dialer script specified !";return 2;fi
	
	# Generate the script 
	if  [ $SENS = in ]; then
		echo -en "/usr/sbin/pppd ${PPPOPTIONSIN} connect \"/usr/sbin/chat $CONNECT\" " >${SCRIPTIN}
		/bin/chmod u+x ${SCRIPTIN}
	else
		echo -en "/usr/sbin/pppd ${PPPOPTIONSOUT} connect \"/usr/sbin/chat $CONNECT\" " >${SCRIPTOUT}
		/bin/chmod u+x ${SCRIPTOUT}
	fi
        if [ $VERBOSE = yes ]; then 
 		if [ $SENS = in ]; then cat ${SCRIPTIN}; else cat ${SCRIPTOUT};fi
	fi
	return 0
}



start () {
	echo -n "Starting pppd...";RET=0

	[ "x$1" != "x" ] && CHAN="$1"

	if [ ! -r "$NETSERV" ]; then echo "Net Service file $NETSERV inexistant or unreadable";return 1;fi	
 	if [ ! -r "$INTFILE" ]; then echo "Interface file $INTFILE inexistant or unreadable";return 1;fi

	# Just look if ppp class entry exists in $NETENV interface service file and fetch a device name
       	DEVICENS=`egrep -v "^#" $NETSERV | grep -ie "ppp" | tr '\t' ' ' | tr -s ' ' | tr '\n' ' '| cut -f1 -d" "`
	# Just look if ppp class entry exists in $INTENV interface service file and fetch a device name
	DEVICEIF=`egrep -v "^#" $INTFILE | grep -ie "ppp" | tr '\t' ' ' | tr -s ' ' | tr '\n' ' '| cut -f2 -d" "`	
	DEVICE=$DEVICEIF		

	# Check if no ~ (tilde) is prefixed to interface. If false, this means set_inter on it but don't ifupdown up it.
        start=yes
        DEVICENS2=`echo ${DEVICENS} | egrep -e "^~" | tr -d "~"`
        if [ ! -z $DEVICENS2 ]; then DEVICENS="$DEVICENS2"; start=no;fi

	echo -n "${DEVICEIF}(ppp):"

		# if an interface has been prepared for...
		if [ ! -z "$DEVICEIF" ]; then
			# If it's in NETSERV...
			if [  ! -z "$DEVICENS" ]; then
				# Sanity class ASSERT : ppp interface referenced in NETSERV and in INTFILE must be the same 
				if [ "$DEVICENS" != "$DEVICEIF" ]; then
					echo -en "\nTwo different ppp interfaces have been found in $NETSERV and in $INTFILE :" 
					echo -en " what should I do ? \t"
					return 1
				else
					# Find out whether it need a ifconfiging now or later
					IFCFG=`grep -ie "LINKOPTIONS=\"" <"$PPPOPTIONFILE" | grep -i "demand"`
					if [ "x$IFCFG" = "x" ]; then IFCFG="later"; else IFCFG="now";fi 
					[ "$VERBOSE" = yes ] && echo -en "Startup ppp session...\t"
					set_pppinter "$DEVICE" $IFCFG "$INTFILE"
					RET=$?
				fi
			else
					 # Find out whether it need a ifconfiging now or later
                                        IFCFG=`grep -ie "LINKOPTIONS=\"" <"$PPPOPTIONFILE" | grep -i "demand"`
                                        if [ "x$IFCFG" = "x" ]; then IFCFG="later"; else IFCFG="now";fi
					[ $VERBOSE = yes ] && echo -en "Non-startup ppp session...\t"
					set_pppinter "$DEVICE" $IFCFG "$INTFILE" 
					RET=$?
			fi
		else
			# no interface has been prepared exit in error.
			echo -en " No ppp device $DEVICE in $INTFILE whereas it's mentionned in $NETSERV...\t"
			return 1
		fi
		
		case $RET in
			0)										 ;;
			1)		echo "Bad argument passing, or invalid type"		;return 1;; # argument inconsistency
			70) RET=$?;	echo "error on insmoding modules"                  		 ;; # modules error 
			90)		echo "Finding PPP device IP address failed"		;return 1;; # find_ip ADR impossible
			91) RET=$?;	echo "Finding PPP device NETMASK address failed"	         ;; # find_ip NETM impossible
			92) RET=$?;	echo "Finding PPP device BROADCAST address failed"               ;; # find_ip BROAD impossible
			93) RET=$?;	echo "Finding PPP device NETWORK address failed"                 ;; # find_ip NETWORK impossible
			94) RET=$?;	echo "Finding PPP device GATEWAY address failed"                 ;; # find_ip GATEWAY impossible
			95)		echo "Finding PPP device REMOTE address failed"		;return 1;; # find_ip REM impossible
			*)		echo "error in setting up interface $DEVICEIF"		;return 2;; 
		esac
		# unset all but ADR REM
		unset NETM BROAD NETW GATE CURINTLINE NEXINTLINE
		if [ -z "$ADR" ] || [ -z "$REM" ]; then 
			echo "Finding PPP device IP address failed or finding PPP device REMOTE address failed"
			echo "Scripts can not be created and configured..."
			return 1
		fi
		 
	# Config dialin  script
	config_dial in $ADR $REM $PPPOPTIONFILE
	
	# Config dialout script
	config_dial out $ADR $REM $PPPOPTIONFILE
	# If it's up to here and an nontilded entry is in NETSERV
	# then it means it's a ppp session on startup 
	if [ $? -eq 0 ] && [ ! -z "$DEVICENS" ]; then
		if [ "$start" = yes ]; then
			# Execute the dialout script and enables board to be called from now on.
			[ $VERBOSE = yes ] && echo -en "Running $SCRIPTOUT...\t"
			# Up interface and start callout session in background.
			exec $SCRIPTOUT 2>&1 1>/dev/null  &
		else
			[ $VERBOSE = yes ] && echo -en "Not Running $SCRIPTOUT...\t"
		fi
	fi

	echo "done."
	unset ADR NETM BROAD NETW GATE REM
 return $RET
}
stop () {
	echo -n "Stopping pppd..."
        if [ ! -r "$NETSERV" ]; then echo "Net Service file $NETSERV inexistant or unreadable";return 1;fi
        if [ ! -r "$INTFILE" ]; then echo "Interface file $INTFILE inexistant or unreadable";return 1;fi

        # Just look if ppp class entry exists in $NETENV interface service file and fetch a device name
        DEVICENS=`egrep -v "^#" $NETSERV | grep -ie "ppp" | tr '\t' ' ' | tr -s ' ' | tr '\n' ' '| cut -f1 -d" "`
        # Just look if ppp class entry exists in $INTENV interface file and fetch a device name
        DEVICEIF=`egrep -v "^#" $INTFILE | grep -ie "ppp" | tr '\t' ' ' | tr -s ' ' | tr '\n' ' '| cut -f2 -d" "`
	# Check if no ~ (tilde) is prefixed to interface. Though it tries to stop all, it need a non-tilded name
        nostart=no
        DEVICENS2=`echo ${DEVICENS} | egrep -e "^~" | tr -d "~"`
	if [ ! -z $DEVICENS ]; then DEVICENS="$DEVICENS";fi
	

	DEVICE=""	
	[ ! -z $DEVICEIF ] && DEVICE=$DEVICEIF
	[ ! -z $DEVICENS ] && DEVICE=$DEVICENS

	ifconfig $DEVICE down >/dev/null 2>/dev/null

	if [ "x$DEVICE" != "x" ]; then
		if [ $VERBOSE != yes ]; then
			/usr/bin/killall pppd 2>/dev/null
		else
			/usr/bin/killall pppd >/dev/null 2>/dev/null
		fi
	else
		/bin/ps | grep pppd 1>/dev/null
		# a hand run pppd is alive, kill it ! 
		if [ "$?" -eq 0 ]; then
			[ $VERBOSE = yes ] && echo "Lone pppd deamon has been found, killing it !"
			if [ $VERBOSE != yes ]; then
				/usr/bin/killall pppd 2>/dev/null
			else	
				/usr/bin/killall pppd >/dev/null 2>/dev/null
			fi
		fi
	fi 

	echo "done."
}
restart () {
	stop 
	/bin/usleep 50
	start
}

status() {
        if [ ! -r "$NETSERV" ]; then echo "Net Service file $NETSERV inexistant or unreadable"
                ifconfig -a
        else
		# Just look if ppp class entry exists in $NETENV interface service file and fetch a device name
		DEVICENS=`egrep -v "^#" $NETSERV | grep -ie "ppp" | tr '\t' ' ' | tr -s ' ' | tr '\n' ' '| cut -f1 -d" "`
		# Just look if ppp class entry exists in $INTENV interface service file and fetch a device name
		DEVICEIF=`egrep -v "^#" $INTFILE | grep -ie "ppp" | tr '\t' ' ' | tr -s ' ' | tr '\n' ' '| cut -f2 -d" "`
		# Check if no ~ (tilde) is prefixed to interface.
		DEVICENS2=`echo ${DEVICENS} | egrep -e "^~" | tr -d "~"`
		if [ ! -z $DEVICENS2 ]; then DEVICENS="$DEVICENS2"; fi


		# Sanity class ASSERT : ppp interface referenced in NETSERV and in INTFILE must be the same
			if [ "x$DEVICENS" = "x" ]; then
				echo -en "Not ppp interface mentionned in $NETSERV"
				return 0
			fi
	
			if [ "x$DEVICENS" != "x" ] && [ "$DEVICENS" != "$DEVICEIF" ]; then
				echo -en "\nTwo different ppp interfaces have been found in $NETSERV and in $INTFILE :"
				echo -en " what should I do ? \t"
				return 1
			else
			       ifupdown $DEVICEIF
			       /bin/ls -l /dev/modem 2>/dev/null
			fi
	fi        
	return 0
}

change_chan() {
	echo -n "Changing modem channel..."	
	found=0
	
	if [ "x$1" != "x" ]; then 
		ARG="$1" 
	else
		echo "Not channel given. Please give one [$CHANNEL] ! Nothing done."
		return 1
	fi

	for i in $CHANNEL
	do 
		if [ "$ARG" = "$i" ]; then 
			found=1
			echo "$i."
			CHAN="$i"
			destroy_modem
			create_modem $CHAN
		fi
	done

	if [ $found -ne 1 ]; then 
		echo -n "$ARG is not a valid channel [$CHANNEL] ! Nothing done."
		return 1
	fi
	echo "done."
}

create_modem () {
		if [ "x$1" != "x" ]; then
                        # create a symlink to duart channel
                        if  [ $VERBOSE = yes ]; then
                                ln -s $1/dev/modem
                        else
                                ln -s $1 /dev/modem 1>/dev/null 2>/dev/null
                        fi
		else 
			return 1
		fi
}

destroy_modem () {
                        # destroy sumlink to /dev/modem
                        if  [ $VERBOSE = yes ]; then
                                rm -f /dev/modem 2>/dev/null
                        else
                                rm -f /dev/modem 2>/dev/null 1>/dev/null 2>/dev/null
                        fi
}

case "$1" in
	start|"")
		start
		create_modem $CHAN
		;;
	stop)
		stop
		destroy_modem
		;;
	restart)
		restart
		;;
	status)
		status
		;;
	chan|channel)
		change_chan $2
		;;
	*)
		echo $"Usage: $0 {start|stop|restart}"
	        exit 1
		;;
esac

RET=$?
unset SERVICE
exit $RET
